# controller

[![npm version](https://badge.fury.io/js/%40chengaoyuan%2Fcontroller.svg)](https://badge.fury.io/js/%40chengaoyuan%2Fcontroller)

[![install size](https://packagephobia.now.sh/badge?p=@chengaoyuan/controller)](https://packagephobia.now.sh/result?p=@chengaoyuan/controller)

[![NPM Downloads](https://img.shields.io/npm/dm/@chengaoyuan/controller.svg?style=flat)](https://npmcharts.com/compare/@chengaoyuan/controller?minimal=true)

## Installation

    $ npm install @chengaoyuan/controller

## Usage

```ts
import * as express from "express";
import { Controller, RequestMapping, RequestPath, Request, Response } from "@chengaoyuan/controller";

const app = express();
app.use(Controller);
app.listen(1234, "0.0.0.0");

@Controller("/api")
class A {
    @RequestMapping({ path: "/test", method: "POST" })
    @RequestMapping({ path: "/test", method: "GET" })
    @RequestMapping({ path: "/test", method: "DELETE" })
    @RequestMapping({ path: "/test", method: "PUT" })
    async test(a: string, b: string) {
        return "OK";
    }

    @RequestMapping("/default_get/:path")
    async default_get(@RequestPath path: string, @Request req: any, @Response res: any) {
        return "OK";
    }
}
```

## Testing

    $ npm test
